﻿using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using Luticate2.Auth.Business.Fields;
using Luticate2.Auth.Business.Fields.DMEC;
using Luticate2.Auth.DataAccess.Models;
using Luticate2.Auth.Dbo.Auth;
using Luticate2.Auth.Dbo.Result;

namespace Luticate2.Auth.Business.Auth.DMEC
{
    public class LuDMECGroupsToModel : LuExpressionConverter<LuGroupDbo, LuGroups>
    {
        public LuDMECGroupsToModel(IServiceProvider serviceProvider) : base(serviceProvider)
        {
        }

        protected override LuResult<Expression> ConvertInternal(Stack<Expression> expressions, Expression baseExpression, LuExpressionConverterOptions options)
        {
            var expression = expressions.Peek();
            if (expression is MemberExpression memberExpression)
            {
                if (MemberMatch(x => x.Id, memberExpression))
                {
                    return MakeMemberAccess(x => x.Id, expressions, baseExpression, options);
                }
                if (MemberMatch(x => x.Name, memberExpression))
                {
                    return MakeMemberAccess(x => x.Name, expressions, baseExpression, options);
                }
            }

            return base.ConvertInternal(expressions, baseExpression, options);
        }
    }
}